---
title: '@media'
slug: Web/CSS/@media
tags:
  - '@media'
  - At-rule
  - CSS
  - Conditional
  - Reference
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>@media</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/At-rule">at-rule</a> can be used to apply part of a style sheet based on the result of one or more <a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">media queries</a>.</span> With it, you specify a media query and a block of CSS to apply to the document if and only if the media query matches the device on which the content is being used.</p>

<div class="note">
<p><strong>Note:</strong> In JavaScript, the rules created using <code>@media</code> can be accessed with the {{domxref("CSSMediaRule")}} CSS object model interface.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<p>The <code>@media</code> at-rule may be placed at the top level of your code or nested inside any other <a href="/en-US/docs/Web/CSS/At-rule#Conditional_group_rules">conditional group at-rule</a>.</p>

<pre class="brush: css no-line-numbers notranslate">/* At the top level of your code */
@media screen and (min-width: 900px) {
  article {
    padding: 1rem 3rem;
  }
}

/* Nested within another conditional at-rule */
@supports (display: flex) {
  @media screen and (min-width: 900px) {
    article {
      display: flex;
    }
  }
}
</pre>

<p>For a discussion of media query syntax, please see <a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries#Syntax">Using media queries</a>.</p>

<h2 id="Description">Description</h2>

<h3 id="Media_types">Media types</h3>

<p>{{page("/en-US/docs/Web/CSS/Media_Queries/Using_media_queries", "Media types")}}</p>

<h3 id="Media_features">Media features</h3>

<p>{{page("/en-US/docs/Web/CSS/Media_Queries/Using_media_queries","Media features")}}</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>To best accommodate people who adjust a site's text size, use <code><a href="/en-US/docs/Learn/CSS/Introduction_to_CSS/Values_and_units#Numeric_values">em</a></code>s when you need a {{cssxref("&lt;length&gt;")}} for your <a href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">media queries</a>.</p>

<p>Both <code><a href="/en-US/docs/Learn/CSS/Introduction_to_CSS/Values_and_units#Numeric_values">em</a></code> and <code><a href="/en-US/docs/Learn/CSS/Introduction_to_CSS/Values_and_units#Numeric_values">px</a></code> are valid units, but <code><a href="/en-US/docs/Learn/CSS/Introduction_to_CSS/Values_and_units#Numeric_values">em</a></code> works better if the user changes the browser text size.</p>

<p>Also consider using Level 4 media queries to improve the user's experience. For example, <code>prefers-reduced-motion</code> to <a href="/en-US/docs/Web/CSS/@media/prefers-reduced-motion">detect if the user has requested that the system minimize the amount of animation</a> or motion it uses.</p>

<h2 id="Security">Security</h2>

<p>Because media queries provide insights into the capabilities—and by extension, the features and design—of the device the user is working with, there is the potential that they could be abused to construct a "fingerprint" which identifies the device, or at least categorizes it to some degree of detail that may be undesirable to users.</p>

<p>Because of this potential, a browser may opt to fudge the returned values in some manner in order to prevent them from being used to precisely identify a computer. A browser might also offer additional measures in this area; for example, if Firefox's "Resist Fingerprinting" setting is enabled, many media queries report default values rather than values representing the actual device state.</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Testing_for_print_and_screen_media_types">Testing for print and screen media types</h3>

<pre class="brush: css notranslate">@media print {
  body { font-size: 10pt; }
}

@media screen {
  body { font-size: 13px; }
}

@media screen, print {
  body { line-height: 1.2; }
}

@media only screen
  and (min-width: 320px)
  and (max-width: 480px)
  and (resolution: 150dpi) {
    body { line-height: 1.4; }
}
</pre>

<p>Introduced in Media Queries Level 4 is a new range syntax that allows for less verbose media queries when testing for any feature accepting a range, as shown in the below examples:</p>

<pre class="brush: css notranslate">@media (height &gt; 600px) {
    body { line-height: 1.4; }
}

@media (400px &lt;= width &lt;= 700px) {
    body { line-height: 1.4; }
}
</pre>

<p>For more examples, please see <a class="internal" href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">Using media queries</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Comment</th>
   <th scope="col">Feedback</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS5 Media Queries', '#media-descriptor-table', '@media descriptors')}}</td>
   <td>Reinstates <code>inverted-colors</code> and Custom Media Queries, which were removed from Level 4.<br>
    Adds <code>prefers-reduced-motion</code>, <code>prefers-reduced-transparency</code>, <code>prefers-contrast</code>, and <code>prefers-color-scheme</code> media features.</td>
   <td><a href="https://github.com/w3c/csswg-drafts/issues">CSS Working Group drafts GitHub issues</a></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Conditional', '#at-media', '@media')}}</td>
   <td>Defines the basic syntax of the <code>@media</code> rule.</td>
   <td><a href="https://github.com/w3c/csswg-drafts/issues">CSS Working Group drafts GitHub issues</a></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS4 Media Queries', '#media', '@media')}}</td>
   <td>
    <p>Adds <code>scripting</code>, <code>pointer</code>, <code>hover</code>, <code>update</code>, <code>overflow-block</code>, and <code>overflow-inline</code> media features.<br>
     Deprecates all media types except for <code>screen</code>, <code>print</code>, <code>speech</code>, and <code>all</code>.<br>
     Makes the syntax more flexible by adding, among other things, the <code>or</code> keyword.</p>
   </td>
   <td><a href="https://github.com/w3c/csswg-drafts/issues">CSS Working Group drafts GitHub issues</a></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Media Queries', '#media0', '@media')}}</td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'media.html#at-media-rule', '@media')}}</td>
   <td>Initial definition.</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.at-rules.media")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a class="internal" href="/en-US/docs/Web/CSS/Media_Queries/Using_media_queries">Using media queries</a></li>
 <li>In JavaScript, <code>@media</code> can be accessed via the CSS object model interface {{domxref("CSSMediaRule")}}.</li>
 <li><a href="/en-US/docs/Web/CSS/Mozilla_Extensions#Media_features">Extended Mozilla media features</a></li>
 <li><a href="/en-US/docs/Web/CSS/Webkit_Extensions#Media_features">Extended WebKit media features</a></li>
</ul>
